### Method

# Gio TlsInteraction ask_password

since: 2.30

#### Declaration [src]

    GTlsInteractionResult
    g_tls_interaction_ask_password (
      GTlsInteraction* interaction,
      GTlsPassword* password,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Run synchronous interaction to ask the user for a password. In general, `g_tls_interaction_invoke_ask_password()` should be used instead of this function.

Derived subclasses usually implement a password prompt, although they may also choose to provide a password from elsewhere. The `password` value will be filled in and then `callback` will be called. Alternatively the user may abort this password request, which will usually abort the TLS connection.

If the interaction is cancelled by the cancellation object, or by the user then `G_TLS_INTERACTION_FAILED` will be returned with an error that contains a `G_IO_ERROR_CANCELLED` error code. Certain implementations may not support immediate cancellation.

Available since: 2.30

#### Parameters

`password`

  Type: `GTlsPassword`

  A `GTlsPassword` object.

  The data is owned by the caller of the method.

`cancellable`

  Type: `GCancellable`

  An optional `GCancellable` cancellation object.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GTlsInteractionResult`

The status of the ask password interaction.